'use strict';
var contextPath = ''
var gemhoUtil = window.gemhoUtil || {}
gemhoUtil.formatDate = function(date, type) {
	var ymd =
		`${date.getFullYear() + 1}-${((date.getMonth()+1)>9?'':'0')+(date.getMonth() + 1)}-${(date.getDate()>9?'':'0')+date.getDate()}`;
	if (type === 'YYYY-MM-DD HH:MM:SS') {
		return ymd + ' 00:00:00';
	}
	return ymd
}
gemhoUtil.getTargetDateYMD = function(dayLength, type) {
	var dayLength = dayLength || 0;
	var tempDate = new Date();
	tempDate.setDate(tempDate.getDate() + dayLength);
	var year = tempDate.getFullYear();
	var month = tempDate.getMonth() + 1 < 10 ? "0" + (tempDate.getMonth() + 1) : tempDate.getMonth() + 1;
	var day = tempDate.getDate() < 10 ? "0" + tempDate.getDate() : tempDate.getDate();
	return year + "-" + month + "-" + day;
}
gemhoUtil.getTargetDateYM = function(dayLength, type) {
	var dayLength = dayLength || 0;
	var tempDate = new Date();
	tempDate.setDate(tempDate.getDate() + dayLength);
	var year = tempDate.getFullYear();
	var month = tempDate.getMonth() + 1 < 10 ? "0" + (tempDate.getMonth() + 1) : tempDate.getMonth() + 1;
	return year + "-" + month;
}
/**
 * 
 * @functionName: getPageName
 * @Description: get page name from URL 
 * @author: zjb
 * 
 */
gemhoUtil.getPageName = function() {
	var pathname = window.location.pathname;
	if (pathname) {
		pathname = pathname.split('/');
		return pathname[pathname.length - 1].split('.')[0];
	} else {
		return '';
	}
}

/**
 * 
 * @functionName: getNavigator
 * @Description: get navigator 
 * @author: zjb
 * 
 */
gemhoUtil.getNavigator = function() {
	var ua = navigator.userAgent.toLowerCase();
	if (ua.indexOf('chrome') != -1) {
		return 'Chrome';
	} else if (ua.indexOf('firefox') != -1) {
		return 'Firefox';
	} else if (ua.indexOf('safari') != -1) {
		return 'Safari';
	} else if (ua.indexOf('opera') != -1) {
		return 'Opera';
	} else {
		return 'Unknow';
	}
}

/**
 * 
 * @functionName: getParameter
 * @Description: get parameter from URL 
 * @author: zjb
 * 
 */
gemhoUtil.getParameter = function(name) {
	var search = location.search;
	if (!search) {
		return false;
	}
	search = search.split('?')
	var data = search[1].split('=');
	if (search[1].indexOf(name) == (-1)) {
		return '';
		return;
	}
	if (search[1].indexOf('&') == (-1)) {
		data = search[1].split('=');
		return data[1];
	} else {
		data = search[1].split('&');
		for (var i = 0; i <= data.length - 1; i++) {
			var l_data = data[i].split('=');
			if (l_data[0] == name) {
				return l_data[1];
				break;
			} else {
				continue;
			}
		}
	}
}

/**
 * 
 * @functionName: setParameter
 * @Description: set parameter to URL 
 * @author: zjb
 * 
 */
gemhoUtil.setParameter = function() {
	if (arguments.length) {
		var url = arguments[0],
			paramsObj = arguments[1];
		if (paramsObj) {
			var parameter = '';
			for (var x in paramsObj) {
				parameter += x + '=' + paramsObj[x] + '&';
			}
			url += '?' + parameter.substr(0, parameter.length - 1);
		}
		return url;
	}
}

/**
 * @functionName: setCookie
 * @Description: set cookies 
 * @author: zjb
 */
gemhoUtil.setCookie = function(name, value, days) {
	var len = arguments.length;
	if (len == 2) {
		var exp = new Date();
		exp.setTime(exp.getTime() + 30 * 24 * 60 * 60 * 1000);
		document.cookie = name + '=' + escape(value) + ';expires=' + exp.toGMTString() + ';path=/';
	} else if (len == 3) {
		var exp = new Date();
		exp.setDate(exp.getDate() + parseInt(days));
		exp.setHours(1, 0, 0, 0);
		document.cookie = name + '=' + escape(value) + ';expires=' + exp.toGMTString() + ';path=/';
	}
}

/**
 * 
 * @functionName: getCookie
 * @Description: get cookies 
 * @author: zjb
 * 
 */
gemhoUtil.getCookie = function(name) {
	if (name === 'whMap' || name === 'columnArr') { // 页面搜索条件记录 更改存取方式
		return localStorage.getItem(name);
	}
	var arr, reg = new RegExp('(^| )' + name + '=([^;]*)(;|$)');
	if (arr = document.cookie.match(reg))
		return unescape(arr[2]);
	else
		return null;
}

/**
 * 
 * @functionName: delCookie
 * @Description: delete cookies 
 * @author: zjb
 * 
 */
gemhoUtil.delCookie = function(name) {
	var exp = new Date();
	exp.setTime(exp.getTime() - 1);
	var cval = getCookie(name);
	if (cval != null)
		document.cookie = name + '=' + cval + ';expires=' + exp.toGMTString() + ';path=/';
}

/**
 * 
 * @functionName: 
 * @Description: 获取url页面名称方法 
 * @param: date
 */
gemhoUtil.getPageName = function() {
	var pageN = window.location.pathname;
	pageN = pageN.substring(pageN.lastIndexOf("/") + 1, pageN.indexOf("."));
	if (pageN) return pageN;
}

/**
 * 跳转页面 更新版本号
 * @param path
 * @returns
 * @demo  navigatePage('/warehouse/company/companyDetail.html?companyId=1002');
 */
gemhoUtil.navigatePage = function(path) {
	if (!path) {
		return;
	}
	var url = contextPath;
	if (path.indexOf('?') > -1) { // 带有参数
		url += path + '&rev=' + (+new Date())
	} else {
		url += path + '?rev=' + (+new Date())
	}
	location.href = url;
}
